# coding: utf-8

"""
    SciCat backend API

    This is the API for the SciCat Backend ============================================

    The version of the OpenAPI document: 4.1.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import re  # noqa: F401
import io
import warnings

from pydantic import validate_arguments, ValidationError

from typing_extensions import Annotated
from pydantic import Field, StrictStr

from typing import List, Optional

from Scicat-pydantic-SDK.models.attachment import Attachment
from Scicat-pydantic-SDK.models.create_attachment_dto import CreateAttachmentDto
from Scicat-pydantic-SDK.models.create_proposal_dto import CreateProposalDto
from Scicat-pydantic-SDK.models.dataset_class import DatasetClass
from Scicat-pydantic-SDK.models.partial_update_attachment_dto import PartialUpdateAttachmentDto
from Scicat-pydantic-SDK.models.partial_update_proposal_dto import PartialUpdateProposalDto
from Scicat-pydantic-SDK.models.proposal_class import ProposalClass

from Scicat-pydantic-SDK.api_client import ApiClient
from Scicat-pydantic-SDK.api_response import ApiResponse
from Scicat-pydantic-SDK.exceptions import (  # noqa: F401
    ApiTypeError,
    ApiValueError
)


class ProposalsApi:
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None) -> None:
        if api_client is None:
            api_client = ApiClient.get_default()
        self.api_client = api_client

    @validate_arguments
    def proposals_controller_create(self, create_proposal_dto : CreateProposalDto, **kwargs) -> ProposalClass:  # noqa: E501
        """It creates a new proposal.  # noqa: E501

        It creates a new proposal and returnes it completed with systems fields.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.proposals_controller_create(create_proposal_dto, async_req=True)
        >>> result = thread.get()

        :param create_proposal_dto: (required)
        :type create_proposal_dto: CreateProposalDto
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: ProposalClass
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the proposals_controller_create_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.proposals_controller_create_with_http_info(create_proposal_dto, **kwargs)  # noqa: E501

    @validate_arguments
    def proposals_controller_create_with_http_info(self, create_proposal_dto : CreateProposalDto, **kwargs) -> ApiResponse:  # noqa: E501
        """It creates a new proposal.  # noqa: E501

        It creates a new proposal and returnes it completed with systems fields.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.proposals_controller_create_with_http_info(create_proposal_dto, async_req=True)
        >>> result = thread.get()

        :param create_proposal_dto: (required)
        :type create_proposal_dto: CreateProposalDto
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(ProposalClass, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'create_proposal_dto'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method proposals_controller_create" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}

        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        if _params['create_proposal_dto'] is not None:
            _body_params = _params['create_proposal_dto']

        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # set the HTTP header `Content-Type`
        _content_types_list = _params.get('_content_type',
            self.api_client.select_header_content_type(
                ['application/json']))
        if _content_types_list:
                _header_params['Content-Type'] = _content_types_list

        # authentication setting
        _auth_settings = ['bearer']  # noqa: E501

        _response_types_map = {
            '201': "ProposalClass",
        }

        return self.api_client.call_api(
            '/api/v3/proposals', 'POST',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def proposals_controller_create_attachment(self, pid : Annotated[StrictStr, Field(..., description="Id of the proposal we would like to create a new attachment for")], create_attachment_dto : CreateAttachmentDto, **kwargs) -> Attachment:  # noqa: E501
        """It creates a new attachement for the proposal specified.  # noqa: E501

        It creates a new attachement for the proposal specified by the pid passed.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.proposals_controller_create_attachment(pid, create_attachment_dto, async_req=True)
        >>> result = thread.get()

        :param pid: Id of the proposal we would like to create a new attachment for (required)
        :type pid: str
        :param create_attachment_dto: (required)
        :type create_attachment_dto: CreateAttachmentDto
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: Attachment
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the proposals_controller_create_attachment_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.proposals_controller_create_attachment_with_http_info(pid, create_attachment_dto, **kwargs)  # noqa: E501

    @validate_arguments
    def proposals_controller_create_attachment_with_http_info(self, pid : Annotated[StrictStr, Field(..., description="Id of the proposal we would like to create a new attachment for")], create_attachment_dto : CreateAttachmentDto, **kwargs) -> ApiResponse:  # noqa: E501
        """It creates a new attachement for the proposal specified.  # noqa: E501

        It creates a new attachement for the proposal specified by the pid passed.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.proposals_controller_create_attachment_with_http_info(pid, create_attachment_dto, async_req=True)
        >>> result = thread.get()

        :param pid: Id of the proposal we would like to create a new attachment for (required)
        :type pid: str
        :param create_attachment_dto: (required)
        :type create_attachment_dto: CreateAttachmentDto
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(Attachment, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'pid',
            'create_attachment_dto'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method proposals_controller_create_attachment" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params['pid'] is not None:
            _path_params['pid'] = _params['pid']


        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        if _params['create_attachment_dto'] is not None:
            _body_params = _params['create_attachment_dto']

        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # set the HTTP header `Content-Type`
        _content_types_list = _params.get('_content_type',
            self.api_client.select_header_content_type(
                ['application/json']))
        if _content_types_list:
                _header_params['Content-Type'] = _content_types_list

        # authentication setting
        _auth_settings = ['bearer']  # noqa: E501

        _response_types_map = {
            '201': "Attachment",
        }

        return self.api_client.call_api(
            '/api/v3/proposals/{pid}/attachments', 'POST',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def proposals_controller_find_all(self, filters : Annotated[Optional[StrictStr], Field(description="Database filters to apply when retrieving proposals <pre>  {    \"where?\": {      \"field\": \"value\"    },    \"include?\": [      {        \"relation\": \"target\",        \"scope\": {          \"where\" : \"<where_condition>\"        ]      }    ],    \"fields?\": [ \"field1\", \"field2\", ...],    \"limits?\": {      \"limit\": number,      \"skip\": number,      \"order\": [ascending, descending]    }  }  </pre>")] = None, **kwargs) -> List[ProposalClass]:  # noqa: E501
        """It returns a list of proposals.  # noqa: E501

        It returns a list of proposals. The list returned can be modified by providing a filter.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.proposals_controller_find_all(filters, async_req=True)
        >>> result = thread.get()

        :param filters: Database filters to apply when retrieving proposals <pre>  {    \"where?\": {      \"field\": \"value\"    },    \"include?\": [      {        \"relation\": \"target\",        \"scope\": {          \"where\" : \"<where_condition>\"        ]      }    ],    \"fields?\": [ \"field1\", \"field2\", ...],    \"limits?\": {      \"limit\": number,      \"skip\": number,      \"order\": [ascending, descending]    }  }  </pre>
        :type filters: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: List[ProposalClass]
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the proposals_controller_find_all_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.proposals_controller_find_all_with_http_info(filters, **kwargs)  # noqa: E501

    @validate_arguments
    def proposals_controller_find_all_with_http_info(self, filters : Annotated[Optional[StrictStr], Field(description="Database filters to apply when retrieving proposals <pre>  {    \"where?\": {      \"field\": \"value\"    },    \"include?\": [      {        \"relation\": \"target\",        \"scope\": {          \"where\" : \"<where_condition>\"        ]      }    ],    \"fields?\": [ \"field1\", \"field2\", ...],    \"limits?\": {      \"limit\": number,      \"skip\": number,      \"order\": [ascending, descending]    }  }  </pre>")] = None, **kwargs) -> ApiResponse:  # noqa: E501
        """It returns a list of proposals.  # noqa: E501

        It returns a list of proposals. The list returned can be modified by providing a filter.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.proposals_controller_find_all_with_http_info(filters, async_req=True)
        >>> result = thread.get()

        :param filters: Database filters to apply when retrieving proposals <pre>  {    \"where?\": {      \"field\": \"value\"    },    \"include?\": [      {        \"relation\": \"target\",        \"scope\": {          \"where\" : \"<where_condition>\"        ]      }    ],    \"fields?\": [ \"field1\", \"field2\", ...],    \"limits?\": {      \"limit\": number,      \"skip\": number,      \"order\": [ascending, descending]    }  }  </pre>
        :type filters: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(List[ProposalClass], status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'filters'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method proposals_controller_find_all" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}

        # process the query parameters
        _query_params = []
        if _params.get('filters') is not None:  # noqa: E501
            _query_params.append(('filters', _params['filters']))

        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = ['bearer']  # noqa: E501

        _response_types_map = {
            '200': "List[ProposalClass]",
        }

        return self.api_client.call_api(
            '/api/v3/proposals', 'GET',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def proposals_controller_find_all_attachments(self, pid : Annotated[StrictStr, Field(..., description="Id of the proposal for which we would like to retrieve all the attachments")], **kwargs) -> List[Attachment]:  # noqa: E501
        """It returns all the attachments for the proposal specified.  # noqa: E501

        It returns all the attachments for the proposal specified by the pid passed.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.proposals_controller_find_all_attachments(pid, async_req=True)
        >>> result = thread.get()

        :param pid: Id of the proposal for which we would like to retrieve all the attachments (required)
        :type pid: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: List[Attachment]
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the proposals_controller_find_all_attachments_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.proposals_controller_find_all_attachments_with_http_info(pid, **kwargs)  # noqa: E501

    @validate_arguments
    def proposals_controller_find_all_attachments_with_http_info(self, pid : Annotated[StrictStr, Field(..., description="Id of the proposal for which we would like to retrieve all the attachments")], **kwargs) -> ApiResponse:  # noqa: E501
        """It returns all the attachments for the proposal specified.  # noqa: E501

        It returns all the attachments for the proposal specified by the pid passed.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.proposals_controller_find_all_attachments_with_http_info(pid, async_req=True)
        >>> result = thread.get()

        :param pid: Id of the proposal for which we would like to retrieve all the attachments (required)
        :type pid: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(List[Attachment], status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'pid'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method proposals_controller_find_all_attachments" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params['pid'] is not None:
            _path_params['pid'] = _params['pid']


        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = ['bearer']  # noqa: E501

        _response_types_map = {
            '200': "List[Attachment]",
        }

        return self.api_client.call_api(
            '/api/v3/proposals/{pid}/attachments', 'GET',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def proposals_controller_find_all_datasets(self, pid : Annotated[StrictStr, Field(..., description="Id of the proposal for which we would like to retrieve all the datasets")], **kwargs) -> List[DatasetClass]:  # noqa: E501
        """It returns all the datasets associated with the proposal indicated.  # noqa: E501

        It returns all the datasets associated with the proposal indicated by the pid parameter.<br>Changes to the related datasets must be performed through the dataset endpoint.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.proposals_controller_find_all_datasets(pid, async_req=True)
        >>> result = thread.get()

        :param pid: Id of the proposal for which we would like to retrieve all the datasets (required)
        :type pid: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: List[DatasetClass]
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the proposals_controller_find_all_datasets_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.proposals_controller_find_all_datasets_with_http_info(pid, **kwargs)  # noqa: E501

    @validate_arguments
    def proposals_controller_find_all_datasets_with_http_info(self, pid : Annotated[StrictStr, Field(..., description="Id of the proposal for which we would like to retrieve all the datasets")], **kwargs) -> ApiResponse:  # noqa: E501
        """It returns all the datasets associated with the proposal indicated.  # noqa: E501

        It returns all the datasets associated with the proposal indicated by the pid parameter.<br>Changes to the related datasets must be performed through the dataset endpoint.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.proposals_controller_find_all_datasets_with_http_info(pid, async_req=True)
        >>> result = thread.get()

        :param pid: Id of the proposal for which we would like to retrieve all the datasets (required)
        :type pid: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(List[DatasetClass], status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'pid'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method proposals_controller_find_all_datasets" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params['pid'] is not None:
            _path_params['pid'] = _params['pid']


        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = ['bearer']  # noqa: E501

        _response_types_map = {
            '200': "List[DatasetClass]",
        }

        return self.api_client.call_api(
            '/api/v3/proposals/{pid}/datasets', 'GET',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def proposals_controller_find_by_id(self, pid : Annotated[StrictStr, Field(..., description="Id of the proposal to return")], **kwargs) -> ProposalClass:  # noqa: E501
        """It returns the proposal requested.  # noqa: E501

        It returns the proposal requested through the pid specified.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.proposals_controller_find_by_id(pid, async_req=True)
        >>> result = thread.get()

        :param pid: Id of the proposal to return (required)
        :type pid: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: ProposalClass
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the proposals_controller_find_by_id_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.proposals_controller_find_by_id_with_http_info(pid, **kwargs)  # noqa: E501

    @validate_arguments
    def proposals_controller_find_by_id_with_http_info(self, pid : Annotated[StrictStr, Field(..., description="Id of the proposal to return")], **kwargs) -> ApiResponse:  # noqa: E501
        """It returns the proposal requested.  # noqa: E501

        It returns the proposal requested through the pid specified.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.proposals_controller_find_by_id_with_http_info(pid, async_req=True)
        >>> result = thread.get()

        :param pid: Id of the proposal to return (required)
        :type pid: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(ProposalClass, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'pid'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method proposals_controller_find_by_id" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params['pid'] is not None:
            _path_params['pid'] = _params['pid']


        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = ['bearer']  # noqa: E501

        _response_types_map = {
            '200': "ProposalClass",
        }

        return self.api_client.call_api(
            '/api/v3/proposals/{pid}', 'GET',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def proposals_controller_find_by_id_access(self, pid : Annotated[StrictStr, Field(..., description="ID of the proposal to check access for")], **kwargs) -> bool:  # noqa: E501
        """Check user access to a specific proposal.  # noqa: E501

        Returns a boolean indicating whether the user has access to the proposal with the specified ID.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.proposals_controller_find_by_id_access(pid, async_req=True)
        >>> result = thread.get()

        :param pid: ID of the proposal to check access for (required)
        :type pid: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: bool
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the proposals_controller_find_by_id_access_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.proposals_controller_find_by_id_access_with_http_info(pid, **kwargs)  # noqa: E501

    @validate_arguments
    def proposals_controller_find_by_id_access_with_http_info(self, pid : Annotated[StrictStr, Field(..., description="ID of the proposal to check access for")], **kwargs) -> ApiResponse:  # noqa: E501
        """Check user access to a specific proposal.  # noqa: E501

        Returns a boolean indicating whether the user has access to the proposal with the specified ID.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.proposals_controller_find_by_id_access_with_http_info(pid, async_req=True)
        >>> result = thread.get()

        :param pid: ID of the proposal to check access for (required)
        :type pid: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(bool, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'pid'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method proposals_controller_find_by_id_access" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params['pid'] is not None:
            _path_params['pid'] = _params['pid']


        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = ['bearer']  # noqa: E501

        _response_types_map = {
            '200': "bool",
        }

        return self.api_client.call_api(
            '/api/v3/proposals/{pid}/authorization', 'GET',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def proposals_controller_find_one_attachment_and_remove(self, pid : Annotated[StrictStr, Field(..., description="Id of the proposal for which we would like to delete the attachment specified")], aid : Annotated[StrictStr, Field(..., description="Id of the attachment of this proposal that we would like to delete")], **kwargs) -> None:  # noqa: E501
        """It deletes the attachment from the proposal.  # noqa: E501

        It deletes the attachment from the proposal.<br>This endpoint is obsolete and will be dropped in future versions.<br>Deleting attachments will be done only from the attachements endpoint.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.proposals_controller_find_one_attachment_and_remove(pid, aid, async_req=True)
        >>> result = thread.get()

        :param pid: Id of the proposal for which we would like to delete the attachment specified (required)
        :type pid: str
        :param aid: Id of the attachment of this proposal that we would like to delete (required)
        :type aid: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: None
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the proposals_controller_find_one_attachment_and_remove_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.proposals_controller_find_one_attachment_and_remove_with_http_info(pid, aid, **kwargs)  # noqa: E501

    @validate_arguments
    def proposals_controller_find_one_attachment_and_remove_with_http_info(self, pid : Annotated[StrictStr, Field(..., description="Id of the proposal for which we would like to delete the attachment specified")], aid : Annotated[StrictStr, Field(..., description="Id of the attachment of this proposal that we would like to delete")], **kwargs) -> ApiResponse:  # noqa: E501
        """It deletes the attachment from the proposal.  # noqa: E501

        It deletes the attachment from the proposal.<br>This endpoint is obsolete and will be dropped in future versions.<br>Deleting attachments will be done only from the attachements endpoint.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.proposals_controller_find_one_attachment_and_remove_with_http_info(pid, aid, async_req=True)
        >>> result = thread.get()

        :param pid: Id of the proposal for which we would like to delete the attachment specified (required)
        :type pid: str
        :param aid: Id of the attachment of this proposal that we would like to delete (required)
        :type aid: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: None
        """

        _params = locals()

        _all_params = [
            'pid',
            'aid'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method proposals_controller_find_one_attachment_and_remove" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params['pid'] is not None:
            _path_params['pid'] = _params['pid']

        if _params['aid'] is not None:
            _path_params['aid'] = _params['aid']


        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # authentication setting
        _auth_settings = ['bearer']  # noqa: E501

        _response_types_map = {}

        return self.api_client.call_api(
            '/api/v3/proposals/{pid}/attachments/{aid}', 'DELETE',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def proposals_controller_find_one_attachment_and_update(self, pid : Annotated[StrictStr, Field(..., description="Id of the proposal for which we would like to update the attachment specified")], aid : Annotated[StrictStr, Field(..., description="Id of the attachment of this proposal that we would like to patch")], partial_update_attachment_dto : PartialUpdateAttachmentDto, **kwargs) -> Attachment:  # noqa: E501
        """It updates the attachment specified for the proposal indicated.  # noqa: E501

        It updates the attachment specified by the aid parameter for the proposal indicated by the pid parameter.<br>This endpoint is obsolete and it will removed in future version.<br>Attachements can be updated from the attachment endpoint.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.proposals_controller_find_one_attachment_and_update(pid, aid, partial_update_attachment_dto, async_req=True)
        >>> result = thread.get()

        :param pid: Id of the proposal for which we would like to update the attachment specified (required)
        :type pid: str
        :param aid: Id of the attachment of this proposal that we would like to patch (required)
        :type aid: str
        :param partial_update_attachment_dto: (required)
        :type partial_update_attachment_dto: PartialUpdateAttachmentDto
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: Attachment
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the proposals_controller_find_one_attachment_and_update_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.proposals_controller_find_one_attachment_and_update_with_http_info(pid, aid, partial_update_attachment_dto, **kwargs)  # noqa: E501

    @validate_arguments
    def proposals_controller_find_one_attachment_and_update_with_http_info(self, pid : Annotated[StrictStr, Field(..., description="Id of the proposal for which we would like to update the attachment specified")], aid : Annotated[StrictStr, Field(..., description="Id of the attachment of this proposal that we would like to patch")], partial_update_attachment_dto : PartialUpdateAttachmentDto, **kwargs) -> ApiResponse:  # noqa: E501
        """It updates the attachment specified for the proposal indicated.  # noqa: E501

        It updates the attachment specified by the aid parameter for the proposal indicated by the pid parameter.<br>This endpoint is obsolete and it will removed in future version.<br>Attachements can be updated from the attachment endpoint.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.proposals_controller_find_one_attachment_and_update_with_http_info(pid, aid, partial_update_attachment_dto, async_req=True)
        >>> result = thread.get()

        :param pid: Id of the proposal for which we would like to update the attachment specified (required)
        :type pid: str
        :param aid: Id of the attachment of this proposal that we would like to patch (required)
        :type aid: str
        :param partial_update_attachment_dto: (required)
        :type partial_update_attachment_dto: PartialUpdateAttachmentDto
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(Attachment, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'pid',
            'aid',
            'partial_update_attachment_dto'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method proposals_controller_find_one_attachment_and_update" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params['pid'] is not None:
            _path_params['pid'] = _params['pid']

        if _params['aid'] is not None:
            _path_params['aid'] = _params['aid']


        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        if _params['partial_update_attachment_dto'] is not None:
            _body_params = _params['partial_update_attachment_dto']

        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # set the HTTP header `Content-Type`
        _content_types_list = _params.get('_content_type',
            self.api_client.select_header_content_type(
                ['application/json']))
        if _content_types_list:
                _header_params['Content-Type'] = _content_types_list

        # authentication setting
        _auth_settings = ['bearer']  # noqa: E501

        _response_types_map = {
            '200': "Attachment",
        }

        return self.api_client.call_api(
            '/api/v3/proposals/{pid}/attachments/{aid}', 'PATCH',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def proposals_controller_fullfacet(self, filters : Annotated[Optional[StrictStr], Field(description="Full facet query filters to apply when retrieving proposals <pre>  {    \"text\": string, <optional>    \"startTime\": { <optional>      \"begin\": string,      \"end\": string,    },    \"proposalId\": { \"regex\": string, \"options\": string }, <optional>    \"title\": { \"regex\": string, \"options\": string }, <optional>    \"firstname\": { \"regex\": string, \"options\": string }, <optional>    \"lastname\": { \"regex\": string, \"options\": string }, <optional>    \"endTime\": { <optional>      \"begin\": string,      \"end\": string,    },    \"userGroups\": [\"group1\", ...],  }    </pre>")] = None, **kwargs) -> List[ProposalClass]:  # noqa: E501
        """It returns a list of proposal facets matching the filter provided.  # noqa: E501

        It returns a list of proposal facets matching the filter provided.<br>This endpoint still needs some work on the filter and facets specification.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.proposals_controller_fullfacet(filters, async_req=True)
        >>> result = thread.get()

        :param filters: Full facet query filters to apply when retrieving proposals <pre>  {    \"text\": string, <optional>    \"startTime\": { <optional>      \"begin\": string,      \"end\": string,    },    \"proposalId\": { \"regex\": string, \"options\": string }, <optional>    \"title\": { \"regex\": string, \"options\": string }, <optional>    \"firstname\": { \"regex\": string, \"options\": string }, <optional>    \"lastname\": { \"regex\": string, \"options\": string }, <optional>    \"endTime\": { <optional>      \"begin\": string,      \"end\": string,    },    \"userGroups\": [\"group1\", ...],  }    </pre>
        :type filters: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: List[ProposalClass]
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the proposals_controller_fullfacet_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.proposals_controller_fullfacet_with_http_info(filters, **kwargs)  # noqa: E501

    @validate_arguments
    def proposals_controller_fullfacet_with_http_info(self, filters : Annotated[Optional[StrictStr], Field(description="Full facet query filters to apply when retrieving proposals <pre>  {    \"text\": string, <optional>    \"startTime\": { <optional>      \"begin\": string,      \"end\": string,    },    \"proposalId\": { \"regex\": string, \"options\": string }, <optional>    \"title\": { \"regex\": string, \"options\": string }, <optional>    \"firstname\": { \"regex\": string, \"options\": string }, <optional>    \"lastname\": { \"regex\": string, \"options\": string }, <optional>    \"endTime\": { <optional>      \"begin\": string,      \"end\": string,    },    \"userGroups\": [\"group1\", ...],  }    </pre>")] = None, **kwargs) -> ApiResponse:  # noqa: E501
        """It returns a list of proposal facets matching the filter provided.  # noqa: E501

        It returns a list of proposal facets matching the filter provided.<br>This endpoint still needs some work on the filter and facets specification.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.proposals_controller_fullfacet_with_http_info(filters, async_req=True)
        >>> result = thread.get()

        :param filters: Full facet query filters to apply when retrieving proposals <pre>  {    \"text\": string, <optional>    \"startTime\": { <optional>      \"begin\": string,      \"end\": string,    },    \"proposalId\": { \"regex\": string, \"options\": string }, <optional>    \"title\": { \"regex\": string, \"options\": string }, <optional>    \"firstname\": { \"regex\": string, \"options\": string }, <optional>    \"lastname\": { \"regex\": string, \"options\": string }, <optional>    \"endTime\": { <optional>      \"begin\": string,      \"end\": string,    },    \"userGroups\": [\"group1\", ...],  }    </pre>
        :type filters: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(List[ProposalClass], status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'filters'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method proposals_controller_fullfacet" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}

        # process the query parameters
        _query_params = []
        if _params.get('filters') is not None:  # noqa: E501
            _query_params.append(('filters', _params['filters']))

        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = ['bearer']  # noqa: E501

        _response_types_map = {
            '200': "List[ProposalClass]",
        }

        return self.api_client.call_api(
            '/api/v3/proposals/fullfacet', 'GET',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def proposals_controller_fullquery(self, limits : Annotated[Optional[StrictStr], Field(description="Define further query parameters like skip, limit, order <pre>  {    \"limit\": number,    \"skip\": number,    \"order\": [ascending, descending]  }  </pre>")] = None, fields : Annotated[Optional[StrictStr], Field(description="Full query filters to apply when retrieving proposals <pre>  {    \"text\": string, <optional>    \"startTime\": { <optional>      \"begin\": string,      \"end\": string,    },    \"proposalId\": { \"regex\": string, \"options\": string }, <optional>    \"title\": { \"regex\": string, \"options\": string }, <optional>    \"firstname\": { \"regex\": string, \"options\": string }, <optional>    \"lastname\": { \"regex\": string, \"options\": string }, <optional>    \"endTime\": { <optional>      \"begin\": string,      \"end\": string,    },    \"userGroups\": [\"group1\", ...],  }    </pre>")] = None, **kwargs) -> List[ProposalClass]:  # noqa: E501
        """It returns a list of proposals matching the query provided.  # noqa: E501

        It returns a list of proposals matching the query provided.<br>This endpoint still needs some work on the query specification.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.proposals_controller_fullquery(limits, fields, async_req=True)
        >>> result = thread.get()

        :param limits: Define further query parameters like skip, limit, order <pre>  {    \"limit\": number,    \"skip\": number,    \"order\": [ascending, descending]  }  </pre>
        :type limits: str
        :param fields: Full query filters to apply when retrieving proposals <pre>  {    \"text\": string, <optional>    \"startTime\": { <optional>      \"begin\": string,      \"end\": string,    },    \"proposalId\": { \"regex\": string, \"options\": string }, <optional>    \"title\": { \"regex\": string, \"options\": string }, <optional>    \"firstname\": { \"regex\": string, \"options\": string }, <optional>    \"lastname\": { \"regex\": string, \"options\": string }, <optional>    \"endTime\": { <optional>      \"begin\": string,      \"end\": string,    },    \"userGroups\": [\"group1\", ...],  }    </pre>
        :type fields: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: List[ProposalClass]
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the proposals_controller_fullquery_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.proposals_controller_fullquery_with_http_info(limits, fields, **kwargs)  # noqa: E501

    @validate_arguments
    def proposals_controller_fullquery_with_http_info(self, limits : Annotated[Optional[StrictStr], Field(description="Define further query parameters like skip, limit, order <pre>  {    \"limit\": number,    \"skip\": number,    \"order\": [ascending, descending]  }  </pre>")] = None, fields : Annotated[Optional[StrictStr], Field(description="Full query filters to apply when retrieving proposals <pre>  {    \"text\": string, <optional>    \"startTime\": { <optional>      \"begin\": string,      \"end\": string,    },    \"proposalId\": { \"regex\": string, \"options\": string }, <optional>    \"title\": { \"regex\": string, \"options\": string }, <optional>    \"firstname\": { \"regex\": string, \"options\": string }, <optional>    \"lastname\": { \"regex\": string, \"options\": string }, <optional>    \"endTime\": { <optional>      \"begin\": string,      \"end\": string,    },    \"userGroups\": [\"group1\", ...],  }    </pre>")] = None, **kwargs) -> ApiResponse:  # noqa: E501
        """It returns a list of proposals matching the query provided.  # noqa: E501

        It returns a list of proposals matching the query provided.<br>This endpoint still needs some work on the query specification.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.proposals_controller_fullquery_with_http_info(limits, fields, async_req=True)
        >>> result = thread.get()

        :param limits: Define further query parameters like skip, limit, order <pre>  {    \"limit\": number,    \"skip\": number,    \"order\": [ascending, descending]  }  </pre>
        :type limits: str
        :param fields: Full query filters to apply when retrieving proposals <pre>  {    \"text\": string, <optional>    \"startTime\": { <optional>      \"begin\": string,      \"end\": string,    },    \"proposalId\": { \"regex\": string, \"options\": string }, <optional>    \"title\": { \"regex\": string, \"options\": string }, <optional>    \"firstname\": { \"regex\": string, \"options\": string }, <optional>    \"lastname\": { \"regex\": string, \"options\": string }, <optional>    \"endTime\": { <optional>      \"begin\": string,      \"end\": string,    },    \"userGroups\": [\"group1\", ...],  }    </pre>
        :type fields: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(List[ProposalClass], status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'limits',
            'fields'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method proposals_controller_fullquery" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}

        # process the query parameters
        _query_params = []
        if _params.get('limits') is not None:  # noqa: E501
            _query_params.append(('limits', _params['limits']))

        if _params.get('fields') is not None:  # noqa: E501
            _query_params.append(('fields', _params['fields']))

        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = ['bearer']  # noqa: E501

        _response_types_map = {
            '200': "List[ProposalClass]",
        }

        return self.api_client.call_api(
            '/api/v3/proposals/fullquery', 'GET',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def proposals_controller_is_valid(self, create_proposal_dto : CreateProposalDto, **kwargs) -> bool:  # noqa: E501
        """It validates the proposal provided as input.  # noqa: E501

        It validates the proposal provided as input, and returns true if the information is a valid proposal  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.proposals_controller_is_valid(create_proposal_dto, async_req=True)
        >>> result = thread.get()

        :param create_proposal_dto: (required)
        :type create_proposal_dto: CreateProposalDto
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: bool
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the proposals_controller_is_valid_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.proposals_controller_is_valid_with_http_info(create_proposal_dto, **kwargs)  # noqa: E501

    @validate_arguments
    def proposals_controller_is_valid_with_http_info(self, create_proposal_dto : CreateProposalDto, **kwargs) -> ApiResponse:  # noqa: E501
        """It validates the proposal provided as input.  # noqa: E501

        It validates the proposal provided as input, and returns true if the information is a valid proposal  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.proposals_controller_is_valid_with_http_info(create_proposal_dto, async_req=True)
        >>> result = thread.get()

        :param create_proposal_dto: (required)
        :type create_proposal_dto: CreateProposalDto
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(bool, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'create_proposal_dto'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method proposals_controller_is_valid" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}

        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        if _params['create_proposal_dto'] is not None:
            _body_params = _params['create_proposal_dto']

        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # set the HTTP header `Content-Type`
        _content_types_list = _params.get('_content_type',
            self.api_client.select_header_content_type(
                ['application/json']))
        if _content_types_list:
                _header_params['Content-Type'] = _content_types_list

        # authentication setting
        _auth_settings = ['bearer']  # noqa: E501

        _response_types_map = {
            '200': "bool",
        }

        return self.api_client.call_api(
            '/api/v3/proposals/isValid', 'POST',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def proposals_controller_remove(self, pid : Annotated[StrictStr, Field(..., description="Id of the proposal to delete")], **kwargs) -> None:  # noqa: E501
        """It deletes the proposal.  # noqa: E501

        It delete the proposal specified through the pid specified.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.proposals_controller_remove(pid, async_req=True)
        >>> result = thread.get()

        :param pid: Id of the proposal to delete (required)
        :type pid: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: None
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the proposals_controller_remove_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.proposals_controller_remove_with_http_info(pid, **kwargs)  # noqa: E501

    @validate_arguments
    def proposals_controller_remove_with_http_info(self, pid : Annotated[StrictStr, Field(..., description="Id of the proposal to delete")], **kwargs) -> ApiResponse:  # noqa: E501
        """It deletes the proposal.  # noqa: E501

        It delete the proposal specified through the pid specified.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.proposals_controller_remove_with_http_info(pid, async_req=True)
        >>> result = thread.get()

        :param pid: Id of the proposal to delete (required)
        :type pid: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: None
        """

        _params = locals()

        _all_params = [
            'pid'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method proposals_controller_remove" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params['pid'] is not None:
            _path_params['pid'] = _params['pid']


        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # authentication setting
        _auth_settings = ['bearer']  # noqa: E501

        _response_types_map = {}

        return self.api_client.call_api(
            '/api/v3/proposals/{pid}', 'DELETE',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def proposals_controller_update(self, pid : Annotated[StrictStr, Field(..., description="Id of the proposal to modify")], partial_update_proposal_dto : PartialUpdateProposalDto, **kwargs) -> ProposalClass:  # noqa: E501
        """It updates the proposal.  # noqa: E501

        It updates the proposal specified through the pid specified. it updates only the specified fields.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.proposals_controller_update(pid, partial_update_proposal_dto, async_req=True)
        >>> result = thread.get()

        :param pid: Id of the proposal to modify (required)
        :type pid: str
        :param partial_update_proposal_dto: (required)
        :type partial_update_proposal_dto: PartialUpdateProposalDto
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: ProposalClass
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the proposals_controller_update_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.proposals_controller_update_with_http_info(pid, partial_update_proposal_dto, **kwargs)  # noqa: E501

    @validate_arguments
    def proposals_controller_update_with_http_info(self, pid : Annotated[StrictStr, Field(..., description="Id of the proposal to modify")], partial_update_proposal_dto : PartialUpdateProposalDto, **kwargs) -> ApiResponse:  # noqa: E501
        """It updates the proposal.  # noqa: E501

        It updates the proposal specified through the pid specified. it updates only the specified fields.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.proposals_controller_update_with_http_info(pid, partial_update_proposal_dto, async_req=True)
        >>> result = thread.get()

        :param pid: Id of the proposal to modify (required)
        :type pid: str
        :param partial_update_proposal_dto: (required)
        :type partial_update_proposal_dto: PartialUpdateProposalDto
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(ProposalClass, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'pid',
            'partial_update_proposal_dto'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method proposals_controller_update" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params['pid'] is not None:
            _path_params['pid'] = _params['pid']


        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        if _params['partial_update_proposal_dto'] is not None:
            _body_params = _params['partial_update_proposal_dto']

        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # set the HTTP header `Content-Type`
        _content_types_list = _params.get('_content_type',
            self.api_client.select_header_content_type(
                ['application/json']))
        if _content_types_list:
                _header_params['Content-Type'] = _content_types_list

        # authentication setting
        _auth_settings = ['bearer']  # noqa: E501

        _response_types_map = {
            '200': "ProposalClass",
        }

        return self.api_client.call_api(
            '/api/v3/proposals/{pid}', 'PATCH',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))
