# coding: utf-8

"""
    SciCat backend API

    This is the API for the SciCat Backend ============================================

    The version of the OpenAPI document: 4.1.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional, Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt, StrictStr, conlist
from Scicat-pydantic-SDK.models.data_file import DataFile

class PartialUpdateDatablockDto(BaseModel):
    """
    PartialUpdateDatablockDto
    """
    owner_group: Optional[StrictStr] = Field(default=None, alias="ownerGroup", description="Name of the group owning this item.")
    access_groups: Optional[conlist(StrictStr)] = Field(default=None, alias="accessGroups", description="List of groups which have access to this item.")
    instrument_group: Optional[StrictStr] = Field(default=None, alias="instrumentGroup", description="Group of the instrument which this item was acquired on.")
    archive_id: Optional[StrictStr] = Field(default=None, alias="archiveId", description="Unique identifier given by the archive system to the stored datablock. This id is used when data is retrieved back.")
    size: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Total size in bytes of all files in the datablock when on accessible.")
    packed_size: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, alias="packedSize", description="Total size in bytes of all files in the datablock when on archived.")
    chk_alg: Optional[StrictStr] = Field(default=None, alias="chkAlg", description="Name of the hashing algorithm used to compute the hash for each file.")
    version: Optional[StrictStr] = Field(default=None, description="Version string defining the format of how data is packed and stored in archive.")
    data_file_list: Optional[conlist(DataFile)] = Field(default=None, alias="dataFileList")
    __properties = ["ownerGroup", "accessGroups", "instrumentGroup", "archiveId", "size", "packedSize", "chkAlg", "version", "dataFileList"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PartialUpdateDatablockDto:
        """Create an instance of PartialUpdateDatablockDto from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in data_file_list (list)
        _items = []
        if self.data_file_list:
            for _item in self.data_file_list:
                if _item:
                    _items.append(_item.to_dict())
            _dict['dataFileList'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PartialUpdateDatablockDto:
        """Create an instance of PartialUpdateDatablockDto from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PartialUpdateDatablockDto.parse_obj(obj)

        _obj = PartialUpdateDatablockDto.parse_obj({
            "owner_group": obj.get("ownerGroup"),
            "access_groups": obj.get("accessGroups"),
            "instrument_group": obj.get("instrumentGroup"),
            "archive_id": obj.get("archiveId"),
            "size": obj.get("size"),
            "packed_size": obj.get("packedSize"),
            "chk_alg": obj.get("chkAlg"),
            "version": obj.get("version"),
            "data_file_list": [DataFile.from_dict(_item) for _item in obj.get("dataFileList")] if obj.get("dataFileList") is not None else None
        })
        return _obj


