# coding: utf-8

"""
    SciCat backend API

    This is the API for the SciCat Backend ============================================

    The version of the OpenAPI document: 4.1.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr, conlist

class PartialUpdateSampleDto(BaseModel):
    """
    PartialUpdateSampleDto
    """
    owner_group: Optional[StrictStr] = Field(default=None, alias="ownerGroup", description="Name of the group owning this item.")
    access_groups: Optional[conlist(StrictStr)] = Field(default=None, alias="accessGroups", description="List of groups which have access to this item.")
    instrument_group: Optional[StrictStr] = Field(default=None, alias="instrumentGroup", description="Group of the instrument which this item was acquired on.")
    owner: Optional[StrictStr] = Field(default=None, description="The owner of the sample.")
    description: Optional[StrictStr] = Field(default=None, description="A description of the sample.")
    sample_characteristics: Optional[Dict[str, Any]] = Field(default=None, alias="sampleCharacteristics", description="JSON object containing the sample characteristics metadata.")
    is_published: Optional[StrictBool] = Field(default=False, alias="isPublished", description="Flag is true when data are made publicly available.")
    __properties = ["ownerGroup", "accessGroups", "instrumentGroup", "owner", "description", "sampleCharacteristics", "isPublished"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PartialUpdateSampleDto:
        """Create an instance of PartialUpdateSampleDto from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PartialUpdateSampleDto:
        """Create an instance of PartialUpdateSampleDto from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PartialUpdateSampleDto.parse_obj(obj)

        _obj = PartialUpdateSampleDto.parse_obj({
            "owner_group": obj.get("ownerGroup"),
            "access_groups": obj.get("accessGroups"),
            "instrument_group": obj.get("instrumentGroup"),
            "owner": obj.get("owner"),
            "description": obj.get("description"),
            "sample_characteristics": obj.get("sampleCharacteristics"),
            "is_published": obj.get("isPublished") if obj.get("isPublished") is not None else False
        })
        return _obj


