# coding: utf-8

"""
    SciCat backend API

    This is the API for the SciCat Backend ============================================

    The version of the OpenAPI document: 4.1.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr

class ReturnedUserDto(BaseModel):
    """
    ReturnedUserDto
    """
    id: StrictStr = Field(default=..., description="Unique id of the user assigned by system")
    username: StrictStr = Field(default=..., description="Username of the user")
    email: StrictStr = Field(default=..., description="Email associated to this user")
    email_verified: Optional[StrictBool] = Field(default=None, alias="emailVerified", description="Email has been verified")
    realm: Optional[StrictStr] = Field(default=None, description="Where the info of this user are stored")
    auth_strategy: StrictStr = Field(default=..., alias="authStrategy", description="Strategy used to authenticate this user")
    __properties = ["id", "username", "email", "emailVerified", "realm", "authStrategy"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ReturnedUserDto:
        """Create an instance of ReturnedUserDto from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ReturnedUserDto:
        """Create an instance of ReturnedUserDto from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ReturnedUserDto.parse_obj(obj)

        _obj = ReturnedUserDto.parse_obj({
            "id": obj.get("id"),
            "username": obj.get("username"),
            "email": obj.get("email"),
            "email_verified": obj.get("emailVerified"),
            "realm": obj.get("realm"),
            "auth_strategy": obj.get("authStrategy")
        })
        return _obj


